;***************************************************************************

;* File Name		:beep.inc

;* Title		:Beep mit Piezo Summer
;* Author		:Ingo Gerlach / DH1AAD

;* Date	 		:29.05.02

;* Version 		:1.0

;* Target MCU		:AT90Sxxx
;* 

;* 
;* Erzeugt mit einem PiezoSummer einen Beep
;***************************************************************************	.
;
; Sub's : beep		nur Beep 
;  	  beep_led	Beep + LEd ein 
;
; Registers Beep
;---------------------------------------------------------------------------
;.def	beep_duration 	= r18 		; Dauer 
;.def	beep_delay1 	= r19 		; Delay 1
;.def	beep_delay2 	= r20 		; Delay 2

; BeepPorts
;---------------------------------------------------------------------------
;.equ	beep_port 	= PORTD		; Port Beeper
;.equ	beep_ddr	= DDRD		; data direction register for port
;.equ	beep_pin 	= 1		; Pin Piezo
;.equ	beep_lport 	= PORTB		; Port Led
;.equ	beep_lddr	= DDRB		; data direction register for port
;.equ	beep_lpin 	= 7		; Pin LED

;.equ	beep_time 	= 255		; Dauer 


; Gesamt Dauer beep_time * beep_delay * 2  = 48 mS 
beep:		ldi	beep_duration,beep_time
beep_x:		sbi	beep_ddr,beep_pin	
		rcall	beep_delay
		cbi	beep_ddr,beep_pin	
		rcall	beep_delay
		dec	beep_duration
		brne	beep_x
		ret

; Beep und Led 
; Gesamt Dauer beep_time * beep_delay * 2  = 48 mS 
beep_led:	ldi	beep_duration,beep_time
beep_y:		sbi	beep_ddr,beep_pin	
		sbi	beep_lddr,beep_lpin	
		rcall	beep_delay
		cbi	beep_ddr,beep_pin	
		cbi	beep_lddr,beep_lpin	
		rcall	beep_delay
		dec	beep_duration
		brne	beep_y
		ret


.def 	tim1		= r20
.def 	tim2		= r21

; Gesamt Dauer 2 * 240 * 250 nS = 120S 
beep_delay:
        ldi     beep_delay1,$02
beep02: ldi     beep_delay2,$F0
beep01: dec     beep_delay2
        brne    beep01
        dec     beep_delay1
        brne    beep02
        ret
