;***************************************************************************
;*
;* ram_str_out / 1.1 26.11.02
;* Gibt den an R30:R31 stehenden String aus
;*     
;***************************************************************************
ram_str_out:
	lpm				; Lade
	mov	lcd_byte,r0		; in Byte schieben
	ori	lcd_byte,$00		; Ende ereicht ? 
	brbs	1,r_stop		; raus
	rcall	LCD_write		; Schreibe Zeichen
	inc	r30			; Byte Counter erhhen
	inc	lcd_pos			; LCD-Pos erhhen
	rjmp	ram_str_out		; Bis zum Stringende 0x00 ausgeben	
r_stop: ret
;* ram_str_out ende

;***************************************************************************
;*
;* show_info_Line /  1.1 26.11.2002 
;* Zeigt nach dem Einschalten Info ber Software
;*     
;***************************************************************************
Show_Info_Line:
	ldi	r31,high(info1_txt*2)   ; Pointer auf Daten , High *2 , da Programm Counter in Word's zhlt
	ldi	r30,low(info1_txt*2)	; Pointer auf Daten , Low
	ldi	lcd_pos,$80		; Start in Zeile 1, Pos 0	
	rcall	ram_str_out		; ausgeben
	ldi	r31,high(info2_txt*2)   ; Pointer auf Daten , High *2 , da Programm Counter in Word's zhlt
	ldi	r30,low(info2_txt*2)	; Pointer auf Daten , Low
	ldi	lcd_pos,$C0		; Start in Zeile 2, Pos 0	
	rcall	ram_str_out
	ret
;* show_info_Lines Ende

;***************************************************************************
;*
;* ShowBCD 1.1 / 08.11.02
;* Anzeige einer BCD Zahl auf dem LC-Display
;* bergabe des Wertes in R24
;* bergabe Position in r23 $80 + Position 1. Zeile $C0 + Position 2. Zeile
;* 
;***************************************************************************
ShowBCD:	ldi	r18,$30		; dez. 48 
		add	lcd_byte,r18	; zum Wert dazuaddieren
		rcall	lcd_write	; und Anzeigen
showende:	ret
; *** ShowBCD, Ende *** 


;***************************************************************************
;*
;* debug_show	/ 7.12.02
;* Anzeige RAM Inhalt auf LCD , Angabe in Y Pointer Setup
;*     
;***************************************************************************
debug_show1:
	rcall	LCD_clear
	ldi	lcd_pos,$80		; 1. Zeile, 1.Pos
	ldi	r19,$05			; 10 Stellen Anzeigen
	ldi	YH,high(ram_bcd)	; die weiteren Stellen automatisch 	
	ldi	YL,low(ram_bcd)		; init Y-pointer
dlooop:	ld	r17,Y+			; 
	mov	lcd_byte,r17
	cbr	lcd_byte,$0F		; unteres Nibble lschen
	swap	lcd_byte
	inc	lcd_pos
	rcall	ShowBCD			; und Anzeigen
	mov	lcd_byte,r17
	cbr	lcd_byte,$F0		; obere Nibble lschen
	inc	lcd_pos
	rcall	ShowBCD			; und Anzeigen
	dec	r19
	brne	dlooop
	ret
; debug_show Ende

;***************************************************************************
;*
;* CheckDP	/ 7.12.02
;* Prft auf DP. Ist Position kleiner , werden fhrende Nullen unterdrckt.
;* Ist Position = PosDP wird DP ausgegeben und Pos erhht , 
;* sonst direkt Ausgabe.    
;***************************************************************************
CheckDp:cp	lcd_pos,R12		; Aktuelle Position kleiner ? 
	breq	cdp			; DP Ausgeben
	brlt	rmnull			; kleiner, also Nullen entfernen
	rjmp	cdsbdc			; Groesser , also einfach nur ausgeben	
cdp:	mov	r27,lcd_byte		; Aktuelle Pos ist DP-Pos
	ldi	lcd_byte,$2e		; DP direkt ausgeben
	rcall	LCD_write		; und Anzeigen
	inc	lcd_pos			; Position erhhen
	mov	lcd_byte,r27		; und original Wert zurckholen
	rjmp	cdsbdc			; und zur Anzeige jumpen...
rmnull: cpi	r20,$01			; Wenn r20 = $01 , wurde bereits eine Zahl != 0 ausgegeben
	breq	cdsbdc			; also direkt anzeigen 
	ldi	r20,$01			; preload $01
	cpi	lcd_byte,$00		; Null ? 
	brne	cdsbdc			; Nein, direkt anzeigen
	ldi	lcd_byte,-16		; ja, mit -16 laden da 48+ (-16) = 32 also Leerzeichen!
	ldi	r20,0			; War eine 0 , also r20=0
cdsbdc:	rcall	ShowBCD			; und Anzeigen
	ret
;* CheckDp Ende

;***************************************************************************
;*
;* Show_Unit	/ 7.12.02
;* Anzeige MHz/Hz abhngig von ram_uflag 0 = MHz, 1 = Hz
;***************************************************************************
Show_Unit:
	ldi	r31,high(mhz_txt*2) 	; Pointer auf Text , High
	ldi	r30,low(mhz_txt*2)	; Pointer auf Text , Low
	lds	r16,ram_uflag		; Flag laden
	cpi	r16,0			; 
	breq	sumhz
	ldi	r31,high(hz_txt*2) 	; Pointer auf Text , High
	ldi	r30,low(hz_txt*2)	; Pointer auf Text , Low
sumhz:	ldi	lcd_pos,$8D		; Start in Zeile 1, Pos D	
	rcall	ram_str_out
	ret
;* Show_Unit Ende

;***************************************************************************
;*
;* Show_Freq	/ 7.12.02
;* Anzeige BCD-RAM Inhalt auf LCD , Angabe in Y Pointer Setup
;* Ist das Ergebnis kleiner als CNT_SWITCH (1048576) wird kein DP 
;* und statt MHZ, Hz  angezeigt.
;***************************************************************************
Show_Freq:
	ldi	lcd_pos,$80		; 1. Zeile, 2.Pos
	ldi	r20,$85			; Pos DP 6. Stelle
	ldi	r19,0			; UFlag 0 = MHz, 1 = Hz
	lds	r16,ram_result+5	; LSB Ergebnis	
	cpi	r16,low(CNT_SWITCH)	; Compare low byte
	ldi	r18,high(CNT_SWITCH)	;
	lds	r17,ram_result+4	; MSB Ergebnis
	cpc	r17,r18			; Compare high byte
	brge	sfdp			; Normal weiter 
	ldi	r20,$8F			; sonst DP so setzen das keiner Angezeigt wird (Hz) !
	ldi	r19,1			; UFlag auf 1 = Hz
	ldi	lcd_pos,$81		; Wenn Anzeige in Hz, 1 Stelle vor
sfdp:	sts	ram_uflag,r19		; Flag zur Anzeige MHZ / Hz speichern
	ldi	r19,$05			; 10 Stellen Anzeigen
	mov	r12,r20			; Position DP steht jetzt in R12
	ldi	YH,high(ram_bcd)	; die weiteren Stellen automatisch 	
	ldi	YL,low(ram_bcd)		; init Y-pointer
sfloop:	ld	r17,Y+			; 1. Byte Laden
	mov	lcd_byte,r17		
	cbr	lcd_byte,$0F		; unteres Nibble lschen
	swap	lcd_byte		; Tauschen
	inc	lcd_pos			; Pos erhhen
	rcall	CheckDp			; und Anzeigen
	mov	lcd_byte,r17		; Unteres Nibble anzeigen
	cbr	lcd_byte,$F0		; obere Nibble lschen
	inc	lcd_pos			; Pos erhhen
	rcall	CheckDp			; und Anzeigen
	dec	r19			; Ende erreicht ?	
	brne	sfloop
	rcall	Show_Unit		; Anzeige MHz/Hz
	ldi	lcd_pos,$80		; Pos OV
	ldi	lcd_byte,' '		; Falls nicht, dann lschen
	lds	temp,ram_ovflag		; berlauf laden
	cpi	temp,$00		; Gesetzt ?
	breq	shf_q			; Nein also raus
	ldi	lcd_byte,'*'		; Sonst * an 1. Position ausgeben
shf_q:	rcall	LCD_write
	ret
; Show_Freq Ende

;***************************************************************************
;*
;* ShowOffset	/ 8.12.02
;* Berechnet Position in der OffsetTab und zeigt die Zeile auf dem Display
;* an.
;*
;***************************************************************************
ShowOffset:
	ldi	r31,high(offset_txt*2)  ; Pointer auf Daten , High *2 , da in Word zhlt
	ldi	r30,low(offset_txt*2)	; Pointer auf Daten , Low
	ldi	lcd_pos,$C0		; Start in Zeile 1, Pos 0	
	rcall	ram_str_out		; Text ausgeben
	lds	r16,ram_bcdsw		; BCDSwitch laden
	ldi	r17,$10			; zum Multiplizieren (Word)
	rcall	mpy8u			; Result in R17
	mov	r30,r17			; Pointer auf Daten , Low
	ldi	r16,TAB_OFF		; Offset Datenbytes Text
	add	r17,r16			; Dazu addieren
	ldi	r31,high(TAB*2)   	; Pointer auf Daten , High *2 , da in Word zhlt
	mov	r7,r17			; r17 Sichern , Ist Position OffsetText
	lpm				; Z-Register 
	sts	ram_offset+0,r0
	inc	r30
	lpm
	sts	ram_offset+1,r0		; Offset Bytes im RAM speichern
	inc	r30

	lpm
	sts	ram_offset+2,r0
	inc	r30

	lpm
	sts	ram_offset+3,r0
	inc	r30

	lpm
	sts	ram_offset+4,r0		; +/- , wenn 1 dann addieren , bei 0 subtrahieren
	inc	r30

	ldi	r31,high(TAB*2)   	; Pointer auf Daten , High *2 , da in Word zhlt
	mov	r30,r7			; Pointer auf Text, Low
	ldi	lcd_pos,$C7		; Start in Zeile 2, Pos 0	
	rcall	ram_str_out	
	ret
;* ShowOffset:
